.set MULTIBOOT_PAGE_ALIGN,      1 << 0
.set MULTIBOOT_MEMORY_INFO,     1 << 1
.set MULTIBOOT_VIDEO_REQUEST,   1 << 2
.set MULTIBOOT_AOUT_KLUDGE,     0 << 16
.set MULTIBOOT_HEADER_MAGIC,    0x1BADB002
.set MULTIBOOT_HEADER_FLAGS, MULTIBOOT_PAGE_ALIGN | MULTIBOOT_MEMORY_INFO | MULTIBOOT_VIDEO_REQUEST | MULTIBOOT_AOUT_KLUDGE
.set MULTIBOOT_CHECKSUM, -(MULTIBOOT_HEADER_MAGIC + MULTIBOOT_HEADER_FLAGS)

#.section ".multiboottbabeee"
.align 4
	.long MULTIBOOT_HEADER_MAGIC
	.long MULTIBOOT_HEADER_FLAGS
	.long MULTIBOOT_CHECKSUM
	.long 0	    # header address
	.long 0	    # load address
	.long 0	    # load end address
	.long 0	    # bss end address
	.long 0	    # entry address
	.long 0	    # video mode_type (0:fb, 1:txt) (set flags[2]!)
	.long 1024  # video width
	.long 768   # video height
	.long 32    # video depth

.bss
.align 16
	stack_bottom:
	.skip 16384     # 16k
	stack_top:

.text
.global  _start
_start:
	# Setup stack
	mov $stack_top, %esp

	# Call the main kernel function.
	push %ebx
	push %eax
	call kmain


	cli
1:      hlt
	jmp 1b
